﻿Public Class Common

    Public Shared Random As New Random
    Public Shared mainUnit As StarA   'プレイヤーのユニット
    Public Shared Display As DisplayInfo  '画面の領域。
    Public Shared StoryBoard As StoryBoard
    Public Shared GamePhase As GamePhases

    Public Shared Event UnitAddRequested(ByVal unit As UnitBase)

    Shared Sub New()
        GamePhase = GamePhases.WaitingForStart
    End Sub
    Public Shared Sub RequestUnitAdd(ByVal unit As UnitBase)
        RaiseEvent UnitAddRequested(unit)
    End Sub

End Class

Public Enum GamePhases
    WaitingForStart
    Playing
    Gameover
End Enum

Public Class Utility

    Public Shared Function GetDistance(ByVal pos1 As Point, ByVal pos2 As Point) As Double

        Dim xDistance As Double = pos1.X - pos2.X
        Dim yDistance As Double = pos1.Y - pos2.Y

        Dim result As Double

        '三平方の定理(ピタゴラスの定理)
        result = Math.Sqrt(xDistance ^ 2 + yDistance ^ 2)

        Return result
    End Function
End Class
