﻿Public Class StoryBoard

    Public StepCount As Integer
    Public MaxStep As Integer
    Public Events As Dictionary(Of Integer, UnitBase)

    Public Sub New()
        Initialize()
    End Sub

    ''' <summary>
    ''' 開発中のデバッグ・テスト用
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub Initialize_()
        Events = New Dictionary(Of Integer, UnitBase)

        AddEvents(10, New Hardian)

        'AddEvents(10, New Titta())
        'AddEvents(20, New Titta())
        'AddEvents(30, New Titta())
        'AddEvents(40, New Titta())
        'AddEvents(50, New Titta())
        'AddEvents(60, New Titta())
        'AddEvents(70, New Titta())
        'AddEvents(80, New Titta())
        'AddEvents(100, New PowerUp)

        MaxStep = 150
    End Sub

    Public Sub Initialize()

        Events = New Dictionary(Of Integer, UnitBase)

        AddEvents(210, New Straighter(), 10)
        AddEvents(220, New Straighter(), 60)
        AddEvents(230, New Straighter(), 110)
        AddEvents(240, New Straighter(), 160)
        AddEvents(250, New Straighter(), 210)
        AddEvents(260, New Straighter(), 260)
        AddEvents(270, New Straighter(), 310)
        AddEvents(280, New Straighter(), 360)

        AddEvents(410, New Straighter(), -10)
        AddEvents(420, New Straighter(), -60)
        AddEvents(430, New Straighter(), -110)
        AddEvents(440, New Straighter(), -160)
        AddEvents(450, New Straighter(), -210)
        AddEvents(460, New Straighter(), -260)
        AddEvents(470, New Straighter(), -310)
        AddEvents(480, New Straighter(), -360)

        AddEvents(500, New PowerUp)

        AddEvents(610, New Galli(), -1)
        AddEvents(620, New Galli(), -1)
        AddEvents(630, New Galli(), -1)
        AddEvents(640, New Galli(), -1)
        AddEvents(650, New Galli(), -1)
        AddEvents(660, New Galli(), -1)
        AddEvents(670, New Galli(), -1)
        AddEvents(680, New Galli(), -1)

        AddEvents(700, New PowerUp)

        AddEvents(810, New Straighter(), 10)
        AddEvents(820, New Straighter(), 60)
        AddEvents(830, New Straighter(), 110)
        AddEvents(840, New Straighter(), 160)
        AddEvents(850, New Straighter(), 210)
        AddEvents(860, New Straighter(), 260)
        AddEvents(870, New Straighter(), 310)
        AddEvents(880, New Straighter(), 360)

        AddEvents(861, New Straighter(), -10)
        AddEvents(871, New Straighter(), -60)
        AddEvents(881, New Straighter(), -110)
        AddEvents(891, New Straighter(), -160)
        AddEvents(901, New Straighter(), -210)
        AddEvents(911, New Straighter(), -260)
        AddEvents(921, New Straighter(), -310)
        AddEvents(931, New Straighter(), -360)

        AddEvents(940, New PowerUp)

        AddEvents(1010, New Titta())
        AddEvents(1020, New Titta())
        AddEvents(1030, New Titta())
        AddEvents(1040, New Titta())
        AddEvents(1050, New Titta())
        AddEvents(1060, New Titta())
        AddEvents(1070, New Titta())
        AddEvents(1080, New Titta())

        AddEvents(1100, New GiantBomber)

        AddEvents(1150, New PowerUp())

        AddEvents(1210, New Straighter())
        AddEvents(1211, New Straighter())
        AddEvents(1212, New Straighter())
        AddEvents(1213, New Straighter())
        AddEvents(1230, New Straighter())
        AddEvents(1231, New Straighter())
        AddEvents(1232, New Straighter())
        AddEvents(1233, New Straighter())
        AddEvents(1260, New Straighter())
        AddEvents(1261, New Straighter())
        AddEvents(1262, New Straighter())
        AddEvents(1263, New Straighter())

        AddEvents(1400, New Hardian(), 400)
        AddEvents(1410, New PowerUp())

        AddEvents(1700, New Hardian(), 200)
        AddEvents(1701, New Hardian(), -200)

        AddEvents(1910, New Galli(), -1)
        AddEvents(1920, New Galli(), -1)
        AddEvents(1930, New Galli(), -1)
        AddEvents(1940, New Galli(), -1)
        AddEvents(1950, New Galli(), -1)
        AddEvents(1960, New Galli(), -1)
        AddEvents(1970, New Galli(), -1)
        AddEvents(1980, New Galli(), -1)

        AddEvents(2010, New Galli(), -1)
        AddEvents(2020, New Galli(), -1)
        AddEvents(2030, New Galli(), -1)
        AddEvents(2040, New Galli(), -1)
        AddEvents(2050, New Galli(), -1)
        AddEvents(2060, New Galli(), -1)
        AddEvents(2070, New Galli(), -1)
        AddEvents(2080, New Galli(), -1)

        AddEvents(2110, New Galli(), -1)
        AddEvents(2115, New Galli(), -1)
        AddEvents(2120, New Galli(), -1)
        AddEvents(2125, New Galli(), -1)
        AddEvents(2130, New Galli(), -1)
        AddEvents(2135, New Galli(), -1)
        AddEvents(2140, New Galli(), -1)
        AddEvents(2145, New Galli(), -1)

        AddEvents(2210, New Titta())
        AddEvents(2220, New Titta())
        AddEvents(2230, New Titta())
        AddEvents(2240, New Titta())
        AddEvents(2250, New Titta())
        AddEvents(2260, New Titta())
        AddEvents(2270, New Titta())
        AddEvents(2280, New Titta())
        AddEvents(2290, New Titta())
        AddEvents(2300, New Titta())
        AddEvents(2310, New Titta())
        AddEvents(2320, New Titta())
        AddEvents(2330, New Titta())
        AddEvents(2340, New Titta())
        AddEvents(2350, New Titta())
        AddEvents(2360, New Titta())

        AddEvents(2400, New GiantBomber)
        AddEvents(2410, New PowerUp())

        AddEvents(2700, New GiantBomber)
        AddEvents(2710, New GiantBomber)
        AddEvents(2720, New GiantBomber)

        AddEvents(3010, New Straighter(), 10)
        AddEvents(3020, New Straighter(), 60)
        AddEvents(3030, New Straighter(), 110)
        AddEvents(3040, New Straighter(), 160)
        AddEvents(3050, New Straighter(), 210)
        AddEvents(3060, New Straighter(), 260)
        AddEvents(3070, New Straighter(), 310)
        AddEvents(3080, New Straighter(), 360)

        AddEvents(3061, New Straighter(), -10)
        AddEvents(3071, New Straighter(), -60)
        AddEvents(3081, New Straighter(), -110)
        AddEvents(3091, New Straighter(), -160)
        AddEvents(3001, New Straighter(), -210)
        AddEvents(3011, New Straighter(), -260)
        AddEvents(3021, New Straighter(), -310)
        AddEvents(3031, New Straighter(), -360)

        AddEvents(3100, New Hardian(), -100)
        AddEvents(3110, New Hardian(), -200)
        AddEvents(3120, New Hardian(), -300)
        AddEvents(3130, New Hardian(), -400)

        AddEvents(3200, New PowerUp())

        AddEvents(3410, New Straighter(), 10)
        AddEvents(3420, New Straighter(), 60)
        AddEvents(3430, New Straighter(), 110)
        AddEvents(3440, New Straighter(), 160)
        AddEvents(3450, New Straighter(), 210)
        AddEvents(3460, New Straighter(), 260)
        AddEvents(3470, New Straighter(), 310)
        AddEvents(3480, New Straighter(), 360)

        AddEvents(3415, New Galli(), -1)
        AddEvents(3425, New Galli(), -1)
        AddEvents(3435, New Galli(), -1)
        AddEvents(3445, New Galli(), -1)
        AddEvents(3455, New Galli(), -1)
        AddEvents(3465, New Galli(), -1)
        AddEvents(3475, New Galli(), -1)
        AddEvents(3485, New Galli(), -1)

        AddEvents(3451, New Titta())
        AddEvents(3461, New Titta())
        AddEvents(3471, New Titta())
        AddEvents(3481, New Titta())

        AddEvents(3462, New GiantBomber)

        AddEvents(3472, New Hardian(), -100)
        AddEvents(3482, New Hardian(), 100)

        AddEvents(3500, New PowerUp())
        AddEvents(3700, New PowerUp())

        MaxStep = 3900
    End Sub

    Private Sub AddEvents(ByVal steps As Integer, ByVal unit As UnitBase)

        Dim x As Integer = Common.Random.Next(1, Common.Display.ViewArea.Width)
        unit.Left = x
        unit.Top = 0
        Events.Add(steps, unit)

    End Sub

    Private Sub AddEvents(ByVal steps As Integer, ByVal unit As UnitBase, ByVal x As Integer)

        If x >= 0 Then
            unit.Left = x
        Else
            unit.Left = Common.Display.ViewArea.Width + x - unit.Width
        End If

        unit.Top = 0
        Events.Add(steps, unit)

    End Sub

    Public Function Tick() As UnitBase
        StepCount += 1

        Dim unit As UnitBase = Nothing
        If Events.Keys.Contains(StepCount) Then
            unit = Events(StepCount)
        End If

        If StepCount = MaxStep Then
            Initialize()
            StepCount = 0
        End If

        Return unit
    End Function

End Class

'Public Class StoryEvent
'    Public Unit As UnitBase
'    'Public Position As Point

'    Public Sub New(ByVal unit As UnitBase)
'        Me.Unit = unit
'        Dim x As Integer = Common.Random.Next(1, Common.Display.ViewArea.Width)
'        unit.Left = x
'        unit.Top = 0
'    End Sub
'End Class
