﻿Public Class Message
    Inherits UnitBase

    Public Font As Font
    Public Brush As Brush
    Public Text As String

    Protected Sub New()
        '
    End Sub
    Public Sub New(ByVal text As String, ByVal x As Integer, ByVal y As Integer, ByVal color As Color, Optional ByVal fontSize As Integer = 18)

        Me.Left = x
        Me.Top = y
        Font = New Font("ＭＳ ゴシック", fontSize, FontStyle.Regular, GraphicsUnit.Pixel)
        Brush = New SolidBrush(color)
        Me.Text = text

    End Sub

    Public Overrides Sub Draw(ByVal g As System.Drawing.Graphics)

        g.DrawString(Text, Font, Brush, Me.Left, Me.Top)

    End Sub

    Public Overrides Property BelongTo As BelongTo
        Get
            Return StarAce.BelongTo.Neutral
        End Get
        Set(ByVal value As BelongTo)
            MyBase.BelongTo = value
        End Set
    End Property

End Class
