﻿Public Class Background
    Inherits UnitBase

    Dim backGroundImage As Bitmap
    Dim mainG As Graphics
    Dim random As New Random
    Dim deltaMove As Integer = 2

    Public Sub New()
        Me.Width = Common.Display.ViewArea.Width
        Me.Height = Common.Display.ViewArea.Height

        backGroundImage = New Bitmap(Me.Width, Me.Height)
        mainG = Graphics.FromImage(backGroundImage)
        Init()
    End Sub

    Public Sub Init()

        mainG.FillRectangle(Brushes.Black, 0, 0, Me.Width, Me.Height)

        For y As Integer = 0 To backGroundImage.Height - 1 Step deltaMove
            Dim x As Integer = random.Next(1, Common.Display.ViewArea.Width)
            mainG.FillRectangle(Brushes.White, x, y, 1, 1)
        Next

    End Sub

    Public Overrides Sub Draw(ByVal g As System.Drawing.Graphics)
       
        Dim y As Integer = Common.Display.ViewArea.Bottom

        Scroll()
        DesignBackGroud()
        g.DrawImage(backGroundImage, New Point(0, 0))

        'g.DrawLine(Pens.Brown, Common.Display.ViewArea.X, y, Common.Display.ViewArea.Right, y)
    End Sub

    Private Sub DesignBackGroud()

        Dim x As Integer = random.Next(1, Common.Display.ViewArea.Width)
        Dim y As Integer = 1 'random.Next(1, Display.ViewArea.Height)
        mainG.FillRectangle(Brushes.White, x, y, 1, 1)

    End Sub

    'Dim dy As Integer
    Private Sub Scroll()

        mainG.DrawImage(backGroundImage, New Point(0, deltaMove))
        mainG.FillRectangle(Brushes.Black, 0, 0, Common.Display.ViewArea.Width, deltaMove)

    End Sub

End Class
