﻿Public Class ExplodeA
    Inherits UnitBase

    Shared Images As New List(Of Bitmap)
    'Private minimumMoveX As Integer = 10
    'Private minimumMoveY As Integer = 8

    'Private IsUe As Boolean '上向きか。
    Shared Attr As New Imaging.ImageAttributes

    Public FrameIndex As Integer
    Public LastFrameIndex As Integer = 16

    ''' <summary>
    ''' 
    ''' </summary>
    ''' <param name="unit">爆発対象のユニット</param>
    ''' <remarks></remarks>
    Public Sub New(ByVal unit As UnitBase)

        'Me.Display = display

        If Images.Count = 0 Then
            'ExplodeA.mainImage = Image.FromFile(Application.StartupPath & "\image\Bomb.bmp")
            '紫を透明色に指定(描画するときに使うだけだけど、毎回設定するのはもったいないので一度だけここで設定)
            Attr.SetColorKey(Color.FromArgb(0, 0, 0), Color.FromArgb(0, 0, 0))


            Dim path As String = Application.StartupPath & "\image\ExplodeA"

            For i As Integer = 0 To 15
                Images.Add(Image.FromFile(path & "\Explode" & i.ToString("00") & ".bmp"))
            Next


        End If

        'IsUe = (Now.Millisecond Mod 2) = 0

        Me.Top = unit.Top
        Me.Left = unit.Left
        Me.Width = Images(0).Width
        Me.Height = Images(0).Height

    End Sub

    Public Overrides Sub Move(ByVal input As InputState)
        FrameIndex += 1
    End Sub

    Public Overrides Sub Draw(ByVal g As System.Drawing.Graphics)

        If FrameIndex = 1 Then
            SoundComposer.Explosion1.Play()
        End If

        If Not Me.IsDead Then
            g.DrawImage(Images(FrameIndex - 1), Me.Rectangle, 0, 0, Me.Width, Me.Height, GraphicsUnit.Pixel, Attr)
        End If

    End Sub

    Public Overrides Function IsDead() As Boolean
        Return FrameIndex > LastFrameIndex
    End Function

    Public Overrides Property BelongTo As BelongTo
        Get
            Return BelongTo.Neutral
        End Get
        Set(ByVal value As BelongTo)
            MyBase.BelongTo = value
        End Set
    End Property
End Class
